
!TOSeasideErrorHandler methodsFor: '*tode-gemstone-seaside' stamp: 'dkh 05/21/2011 04:36'!
remoteBreakpointMethod
	"Special marker method ... causes OTRemoteDebugger to be used for debugging"
	
	^self! !

!TOSeasideErrorHandler methodsFor: '*tode-gemstone-seaside' stamp: 'dkh 07/21/2011 15:17'!
saveExceptionContinuation: anException

	| continuation action |
	 GRPlatform current canDebugInteractively
		ifTrue: [ anException pass ].
	action := [:cont | continuation := cont. #create ] callCC.
	action == #create
		ifTrue: [ | logEntry|
			"Dump the stack to the log file on the off chance that the error is lost in the event of a commit failure"
			GRPlatform current logError: anException description title: 'Error (continuation logged)'.
			WACurrentRequestContext value forDebugging: true.
			logEntry := WAObjectLogEntry 
				error: anException description 
				request: WACurrentRequestContext value request
				continuation: continuation.
			"the continuation is not resumable"
			logEntry resumeContinuation.
			logEntry addToLog.
			^self].
	action == #debug
		ifTrue: [ | meth |
			meth := self class lookupSelector: #remoteBreakpointMethod.
			meth setBreakAtStepPoint: 1.
			self remoteBreakpointMethod ].
! !

!TOMain methodsFor: '*tode-gemstone-seaside' stamp: 'dkh 07/27/2011 11:25'!
windowTitle
	| stoneName userId |
	stoneName := System stoneName copyAfterLast: $!!.
	userId := System myUserProfile userId.
	^ 'tODE [' , stoneName , ':' , userId , ']'! !

!TOSeasideCache methodsFor: '*tode-gemstone-seaside' stamp: 'dkh 08/09/2011 14:57'!
recordReapEnd: expiredCount
	System _sessionCacheStatAt: 5 put: (System _sessionCacheStatAt: 5) + 1.
	System _sessionCacheStatAt: 6 put: expiredCount! !

!TOSeasideCache methodsFor: '*tode-gemstone-seaside' stamp: 'dkh 08/09/2011 14:56'!
recordReapStart
	System _sessionCacheStatAt: 6 put: 0! !

!TOSeasideSession methodsFor: '*tode-gemstone-seaside' stamp: 'dkh 08/09/2011 10:30'!
createCache
	"To configure the continuation cache you must currently subclass WASession and
	override this method."
	^ TOSeasideCache new
		setExpiryPolicy: (WARcLastAccessExpiryPolicy new);
		yourself.! !
